import 'dart:ui';

import 'package:flutter/cupertino.dart';

class NuntioText {
  // general
  late String passwordHint;
  late String identifierHint;
  late String missingIdentifierTitle;
  late String missingIdentifierDescription;
  late String missingPasswordTitle;
  late String missingPasswordDescription;
  late String errorTitle;
  late String errorDescription;
  late String noWifiTitle;
  late String noWifiDescription;

  // welcome
  late String welcomeTitle;
  late String welcomeDetails;

  // register
  late String registerTitle;
  late String registerDetails;
  late String registerButton;
  late String repeatPasswordHint;
  late String passwordDoNotMatchTitle;
  late String passwordDoNotMatchDescription;
  late String passwordContainsEightCharsHint;
  late String passwordContainsSpecialHint;
  late String passwordContainsNumberHint;
  late String passwordsMustMatchHint;

  // login
  late String loginTitle;
  late String loginDetails;
  late String loginButton;
  late String forgotPasswordDetails;
  late String verificationCodeTitle;

  NuntioText({
    String? passwordHint,
    String? identifierHint,
    String? missingIdentifierTitle,
    String? missingIdentifierDescription,
    String? missingPasswordTitle,
    String? missingPasswordDescription,
    String? errorTitle,
    String? errorDescription,
    String? noWifiTitle,
    String? noWifiDescription,
    String? welcomeTitle,
    String? welcomeDetails,
    String? registerTitle,
    String? registerDetails,
    String? registerButton,
    String? repeatPasswordHint,
    String? passwordDoNotMatchTitle,
    String? passwordDoNotMatchDescription,
    String? passwordContainsEightCharsHint,
    String? passwordContainsSpecialHint,
    String? passwordContainsNumberHint,
    String? passwordsMustMatchHint,
    String? loginTitle,
    String? loginDetails,
    String? loginButton,
    String? forgotPasswordDetails,
    String? verificationCodeTitle,
  }) {
    this.passwordHint = passwordHint ?? "Enter your password";
    this.identifierHint = passwordHint ?? "Enter your email";
    this.missingIdentifierTitle = passwordHint ?? "Missing required email";
    this.missingIdentifierDescription = passwordHint ??
        "Please enter your email to login/register your account";
    this.missingPasswordTitle = passwordHint ?? "Missing required password";
    this.missingPasswordDescription = passwordHint ??
        "Please enter your password to login/register your account";
    this.errorTitle = passwordHint ?? "Something went wrong";
    this.errorDescription =
        passwordHint ?? "We encountered an error. Please try again.";
    this.noWifiTitle = passwordHint ?? "No wifi connection";
    this.noWifiDescription = passwordHint ??
        "We cannot authenticate your credentials without a valid wifi or data connection";
    this.welcomeTitle = passwordHint ?? "Welcome";
    this.welcomeDetails =
        passwordHint ?? "Register for an account or sign in below";
    this.registerTitle = passwordHint ?? "Register";
    this.registerDetails =
        passwordHint ?? "Fill in the details below to register for an account";
    this.registerButton = passwordHint ?? "Register account";
    this.repeatPasswordHint = passwordHint ?? "Repeat your password";
    this.passwordDoNotMatchTitle = passwordHint ?? "Passwords do not match";
    this.passwordDoNotMatchDescription =
        passwordHint ?? "The entered password and repeat password do not match";
    this.passwordContainsEightCharsHint =
        passwordHint ?? "Password must contain 8 chars";
    this.passwordContainsSpecialHint =
        passwordHint ?? "Password must contain special char";
    this.passwordContainsNumberHint =
        passwordHint ?? "Password must contain number";
    this.passwordsMustMatchHint =
        passwordHint ?? "The two passwords must match";
    this.loginTitle = passwordHint ?? "Login";
    this.loginDetails =
        passwordHint ?? "Fill in the details below to login to your account";
    this.loginButton = passwordHint ?? "Login";
    this.forgotPasswordDetails = passwordHint ?? "Forgot your password?";
    this.verificationCodeTitle =
        passwordHint ?? "Enter provided verification code";
  }
}

class NuntioTextStyle {
  /*
  late TextStyle titleStyle;
  late TextStyle descriptionStyle;
  late TextStyle bodyTextStyle;
  late TextStyle loginButtonTextStyle;
  late TextStyle registerButtonTextStyle;
  NuntioTextStyle({
    TextStyle? descriptionStyle,
}){
    this.descriptionStyle = descriptionStyle ?? TextStyle()
  }
   */
}

class NuntioColor {
  late Color primaryColor;
  late Color secondaryColor;
  late Color successColor;
  late Color errorColor;
  NuntioColor({
    Color? primaryColor,
    Color? secondaryColor,
    Color? successColor,
    Color? errorColor,
  }) {
    this.primaryColor = primaryColor ?? const Color(0xff0080ff);
    this.secondaryColor = secondaryColor ?? CupertinoColors.lightBackgroundGray;
    this.successColor = successColor ?? CupertinoColors.black;
    this.errorColor = errorColor ?? CupertinoColors.systemBlue;
  }
}
